/* 
   pl_main.m 

   This file is the main driver for the plist parsing program.
   
   Copyright (C) 1996,1999,2000 Free Software Foundation, Inc.

   Author: Gregory John Casamento
   Date: 17 Jan 2000 
   
   This file is part of GNUstep

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; see the file COPYING.LIB.
   If not, write to the Free Software Foundation,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/ 


#import <Foundation/Foundation.h>

// forward declarations for functions...
NSData *process_plist( NSData* inputData );
NSData *read_input();
void create_output( NSData *outputData );

int main (int argc, const char *argv[])
{
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
    NSData *inputData = nil;
    id propertyList = nil;
    
    // put your code here.
    if(argc == 1 || argc == 3|| argc == 5)
    {
    	inputData = read_input();
	if( inputData != nil )
        {
            // If the input data was sucessfully read...
            propertyList = process_plist( inputData );
            if( propertyList != nil )
            {
                // If the property list was okay...
                create_output( propertyList );
            }
        }
    }
    else
    {
        puts("pl {-input <serialized_file>} {-output <serialized_file>}");
        puts("   - Reads an ASCII property list from standard in, or a serialized one");
        puts("     if -input is specified.");
        puts("   - Writes an ASCII propert list to standard out, or a serialized one");
        puts("     if -output is specified.");
    }
    
    [pool release];
    exit(0);       // insure the process exit status is 0
    return 0;      // ...and make main fit the ANSI spec.
}
